/***************************************************************************
 *            wn.c
 *
 *  Fri Apr 16 13:56:50 2004
 *  Copyright  2004  Marcin Krzywonos
 *  e-mail: mkk@akcja.pl
 ****************************************************************************/


#include "var.h"
#include "wn.h"


// Zapisanie wpisu dziennika
void wn_zapisz_notatke ()
{
	// Wczytanie zawartosci widgetu edytora (wd_edytor) do zmiennej notatka
	char *notatka;
	GtkWidget *wd_edytor = lookup_widget (GTK_WIDGET (wd_widget), "wd_edytor");
	GtkTextIter start, end;
	GtkTextBuffer *text_buffer;
	text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (wd_edytor));
	gtk_text_buffer_get_bounds (text_buffer, &start, &end);
	notatka = gtk_text_buffer_get_text (text_buffer, &start, &end, TRUE);
	
	// Proba zapisu wpisu dziennika
	char nazwa_pliku[100];
	sprintf (nazwa_pliku, ".gnutu/dziennik/%d-%d-%d.gtu", biezaca_data.dzien, (biezaca_data.miesiac + 1), biezaca_data.rok);
	FILE *plik = fopen (nazwa_pliku, "w");
	
	// W przypadku niepowodzenia zostanie podjeta proba utworzenia
	// katalogu dziennika i ponownego otwarcia pliku
	if (plik == NULL) {
		system ("mkdir .gnutu/dziennik");
		plik = fopen (nazwa_pliku, "w");
	}
	
	if (plik != NULL) {
		fputs (notatka, plik);
		fclose (plik);
	} else {
		// Jezeli nie udalo sie otworzyc pliku wyswietlamy komunikat bledu
		printf ("BLAD: Nie mozna zapisac pliku dziennika (%s) !\n", nazwa_pliku);
		return;
	}
	
	// Jezeli wpis jest pusty to zostaje on usuniety
	if (strlen (notatka) == 0)
		remove (nazwa_pliku);
}


// Wczytywanie pliku dziennika
void wn_wczytaj_notatke ()
{
	char  tekst[4096];      // Zmienna przechowuje pojedyncza linijke tekstu
	char  nazwa_pliku[100]; // Zmienna przechowuje nazwe pliku dziennika
	// Wygenerowanie nazwy pliku na podstawie daty edytowanego wpisu
	sprintf (nazwa_pliku, ".gnutu/dziennik/%d-%d-%d.gtu", biezaca_data.dzien, (biezaca_data.miesiac + 1), biezaca_data.rok);
	
	FILE *plik = fopen (nazwa_pliku, "r");

	// Jezeli plik zostal otwarty to wczytujemy go
	if (plik != NULL) {
		GtkWidget *wd_edytor       = lookup_widget (GTK_WIDGET (wd_widget), "wd_edytor");
		GtkTextBuffer *text_buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (wd_edytor));
		
		// Wczytujemy tekst
		while (!feof (plik)) {
			fgets (tekst, 8192, plik);
			gtk_text_buffer_insert_at_cursor (text_buffer, tekst, strlen (tekst));
		}
		
		fclose (plik);
	}
}
