/***************************************************************************
 *            wpref.c
 *
 *  Sat Mar 27 12:45:41 2004
 *  Copyright  2004  Marcin Krzywonos
 *  e-mail: mkk@akcja.pl
 ****************************************************************************/


#include "wpref.h"
#include "engine.h"


int wp_wolne_dni_zaznaczony = 0;


void zapisz_ustawienia_glowne ()
{
	GtkWidget *wp_zapis_bazy              = lookup_widget (GTK_WIDGET (wp_widget), "wp_zapis_bazy");
	GtkWidget *wp_automatyczne_wstawianie = lookup_widget (GTK_WIDGET (wp_widget), "wp_automatyczne_wstawianie");
	GtkWidget *wp_najblizsze_sprawdziany = lookup_widget (GTK_WIDGET (wp_widget), "wp_najblizsze_sprawdziany");
	
	gboolean zapis_bazy              = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wp_zapis_bazy));
	gboolean automatyczne_wstawianie = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wp_automatyczne_wstawianie));
	gboolean najblizsze_sprawdziany  = gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (wp_najblizsze_sprawdziany));
	
	strcpy (ustawienia[0], gboolean_to_char (zapis_bazy));
	strcpy (ustawienia[1], gboolean_to_char (automatyczne_wstawianie));
	strcpy (ustawienia[2], gboolean_to_char (najblizsze_sprawdziany));
}


void wp_wolne_dni_dodaj_dzien_wolny ()
{
	int wartosc;
	typ_data tmp;
	
	GtkWidget *wp_dzien = lookup_widget (GTK_WIDGET (wp_widget), "wp_dzien");
	tmp.dzien = gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (wp_dzien));
	
	GtkWidget *wp_miesiac = lookup_widget (GTK_WIDGET (wp_widget), "wp_miesiac");
	tmp.miesiac = gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (wp_miesiac));
	
	GtkWidget *wp_rok = lookup_widget (GTK_WIDGET (wp_widget), "wp_rok");
	tmp.rok = gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (wp_rok));
	
	if (wolne_dni_istnieje (tmp) == FALSE) {
		GtkWidget *wp_wolne_dni = lookup_widget (GTK_WIDGET (wp_widget), "wp_wolne_dni");
	char tmp_str[10];
		sprintf (tmp_str, "%d-%d-%d", tmp.dzien, tmp.miesiac, tmp.rok);
		char *ins_str[] = {tmp_str};
		gtk_clist_insert (GTK_CLIST (wp_wolne_dni), 0, ins_str);
		
		wolne_dni_dodaj (tmp);
	}
}


void wp_wolne_dni_usun_dzien_wolny ()
{
	GtkWidget *wp_wolne_dni = lookup_widget (GTK_WIDGET (wp_widget), "wp_wolne_dni");
	
	char     *tmp_str;
	typ_data  tmp_data;
	gtk_clist_get_text (GTK_CLIST (wp_wolne_dni), wp_wolne_dni_zaznaczony, 0, &tmp_str);
	sscanf (tmp_str, "%d-%d-%d", &tmp_data.dzien, &tmp_data.miesiac, &tmp_data.rok);
	
	gtk_clist_remove (GTK_CLIST (wp_wolne_dni), wp_wolne_dni_zaznaczony);
	wolne_dni_usun (tmp_data);
}


void wp_wolne_dni_wypelnij ()
{
	GtkWidget *wp_wolne_dni = lookup_widget (GTK_WIDGET (wp_widget), "wp_wolne_dni");
	
	gtk_clist_freeze (GTK_CLIST (wp_wolne_dni));
	gtk_clist_clear (GTK_CLIST (wp_wolne_dni));
	
	int   licznik = 0;
	char  tmp_str[10];
	char *ins_str;
	
	while (licznik != 255) {
		if ((wolne_dni[licznik].dzien != 0) & (wolne_dni[licznik].miesiac != 0) & (wolne_dni[licznik].rok != 0)) {
			if ((wolne_dni[licznik].dzien != 100) & (wolne_dni[licznik].miesiac != 100) & (wolne_dni[licznik].rok != 1000)) {
				sprintf (tmp_str, "%d-%d-%d", wolne_dni[licznik].dzien, wolne_dni[licznik].miesiac, wolne_dni[licznik].rok);
				ins_str = tmp_str;
				gtk_clist_insert (GTK_CLIST (wp_wolne_dni), 0, &ins_str);
			}
		} else {
			break;
		}
		
		licznik++;
	}
	
	gtk_clist_thaw (GTK_CLIST (wp_wolne_dni));
}


void wp_wczytaj_ustawienia ()
{
	gboolean zapis_bazy              = char_to_gboolean (ustawienia[0]);
	gboolean automatyczne_wstawianie = char_to_gboolean (ustawienia[1]);
	gboolean najblizsze_sprawdziany  = char_to_gboolean (ustawienia[2]);
	
	GtkWidget *wp_zapis_bazy              = lookup_widget (GTK_WIDGET (wp_widget), "wp_zapis_bazy");
	GtkWidget *wp_automatyczne_wstawianie = lookup_widget (GTK_WIDGET (wp_widget), "wp_automatyczne_wstawianie");
	GtkWidget *wp_najblizsze_sprawdziany  = lookup_widget (GTK_WIDGET (wp_widget), "wp_najblizsze_sprawdziany");
	
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (wp_zapis_bazy), zapis_bazy);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (wp_automatyczne_wstawianie), automatyczne_wstawianie);
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (wp_najblizsze_sprawdziany), najblizsze_sprawdziany);
}


void wp_zapisz_ustawiennia ()
{
	zapisz_wolne_dni         ();
	zapisz_ustawienia_glowne ();
	
	zapisz_ustawienia        ();
	wczytaj_ustawienia       ();
}


void wp_wolne_dni_zaznaczony_zmien (int numer)
{
	wp_wolne_dni_zaznaczony = numer;
}


void wczytaj_ustawienia ()
{
	FILE *plik;
	int   i = 0;
	
	while (i != 50) {
		strcpy (ustawienia[i], "");
		i++;
	}
	
	if ((plik = fopen (".gnutu/ustawienia.gtuconf", "r")) == NULL) {
		printf ("BLAD: Nie mozna otworzyc pliku ustawien (ustawienia.gtuconf) !\n");
		ustawienia_domyslne ();
	} else {
		fread (&ustawienia, sizeof (ustawienia), 1, plik);
		fclose (plik);
	}
}


void zapisz_ustawienia ()
{
	FILE *plik;
	
	if ((plik = fopen (".gnutu/ustawienia.gtuconf", "w")) == NULL) {
		printf ("BLAD: Nie mozna otworzyc pliku ustawien (ustawienia.gtuconf) !\n");
	} else {
		fwrite (&ustawienia, sizeof (ustawienia), 1, plik);
		fclose (plik);
	}
}

void ustawienia_domyslne ()
{
	strcpy (ustawienia[0], "TRUE");
	strcpy (ustawienia[1], "TRUE");
	strcpy (ustawienia[2], "TRUE");
}
